<template lang="pug">
  .root-post
    .upload_modal(v-if="uploader.progress !== null")
      .upload_container
        img.pict(src="@/assets/pict_sending.svg")
        .text
          img.sending(src="@/assets/text_sending.svg" alt="送信中..." height="25")
          span.progress {{Math.floor(uploader.progress)}}% ...
    img.title(src='@/assets/title_post_photo.svg' alt="写真を投稿する" height="52")
    .preview(v-if="uploader.input.blob")
      img( :src="uploader.input.blob")
      button.close(icon="close" @click="reset") ×
    .preview(v-else="uploader.input.blob")
      img(
        src="@/assets/noimg.png"
        @click="triggerSelect"
        for="file"
      )
    input(
      id="file"
      type="file"
      accept="image/*"
      style="display:none"
      name="file"
      ref="fileInput"
      @change="selected"
    )
    div(style="margin: 20px 0")
      my-button.btn(
        type="primary"
        @click="submit"
        v-if="uploader.input.file"
      )
        img(src="@/assets/btn_text_post.svg" alt="写真を投稿" height="16")
      my-button.btn(
        type="primary"
        for="file"
        @click="triggerSelect"
        v-if="!uploader.input.blob"
      )
        img(src="@/assets/btn_text_select_photo.svg" alt="写真を選ぶ" height="16")
      my-button.btn(
        for="file"
        type="secondry"
        @click="triggerSelect"
        v-else
      )
        img(src="@/assets/btn_text_select_other.svg" alt="別の写真を選ぶ" height="16")
      my-button.btn(
        type="plane"
        size="small"
        @click="push('/top')"
      )
        img(src="@/assets/btn_gotop.svg" alt="topへ" height="17")
    p.error(v-if="uploader.error" style="color-red") {{uploader.error}} 
</template>
<script>
import { mapActions, mapGetters } from 'vuex'
import MyButton from '@/components/atoms/Button'
import MyPhotoTable from '@/components/organisms/PhotoTable'
import MyPhotoShower from '@/components/organisms/PhotoShower'
import MyModal from '@/components/organisms/Modal'
import EXIF from 'exif-js'
import router from '@/router/index'

export default {
  name: 'Top',
  components: {
    MyButton,
    MyPhotoTable,
    MyPhotoShower,
    MyModal
  },
  props: {
    // store
  },
  data() {
    return {
      photoIds: []
    }
  },
  computed: {
    ...mapGetters('Auth', {
      userName: 'userName',
      isApproved: 'isApproved',
      userId: 'userId'
    }),
    ...mapGetters('Top', {
      modal: 'modal'
    }),
    ...mapGetters('Photos', {
      uploader: 'getUploader'
    })
  },
  methods: {
    ...mapActions('Top', {
      close: 'close',
      openLightBox: 'openLightBox',
      changeLightBox: 'changeLightBox'
    }),
    ...mapActions('Photos', {
      upload: 'upload',
      onChangeFile: 'onChangeFile'
    }),
    push(path){
      router.push(path)
    },
    triggerSelect() {
      this.$refs.fileInput.click()
    },
    reset() {
      this.onChangeFile({ type: 'reset' })
    },
    selected(e) {
      const input = {}
      const file = (input.file = e.target.files[0])
      console.log(file)
      EXIF.getData(file, () => {
        input.orientation = file.exifdata.Orientation
      })
      if (!file) {
        input.blob = ''
      }
      if (!file.type.match('image.*')) {
        return
      }
      const reader = new FileReader()
      reader.readAsDataURL(file)
      reader.onload = () => {
        input.blob = reader.result
        this.onChangeFile(input)
      }
    },
    submit() {
      const input = this.uploader.input
      const userdata = {
        userId: this.userId,
        userName: this.userName
      }
      const name = file.name
      this.upload({ input, userdata })
    },
  }
}
</script>
<style lang="stylus">
.root-post
  padding-top 4px
  padding-bottom 100px
  width 90%
  max-width 420px
  margin 0 auto
  .title
    margin-bottom $margin-l
  .preview
    margin-bottom $margin-l
    display: inline-block
    position: relative
    width 100%
    &.isBlank
      max-width 200px
    img
      width 100%
    .close
      position: absolute
      top: 5px
      right: 5px
  .btn + .btn
    margin-top $margin-s
  .btn
    margin-left auto 
    margin-right auto
  .upload_modal
    position fixed
    z-index 9999
    width 100%
    height 100%
    background $c-bg
    top 0
    left 0
    .upload_container
      width 250px
      height 250px
      position absolute
      top 0
      left 0
      right 0
      bottom 0
      margin auto
      display flex
      justify-content center
      align-items center
      flex-direction column
      .pict
        top 0
        left 0
        position absolute
        width 250px
        animation sending 10s linear 0s infinite
      .sending
      .progress
        display block
      .progress
        color $c-primary

@keyframes sending
  0%
    transform: rotate(0deg);
  100%
    transform: rotate(360deg);
</style>
